
#import "Controller.h"


static void runOneTick(DPSTimedEntry timedEntry, double timeNow, void *data)
{
    [(id)data ping:timeNow];
	return;
}




@implementation Controller

- appDidInit:sender
{	
	malloc_singlethreaded();

	if(-1==(textFile=open(CONSOLE,O_RDONLY)))
	{
		NXRunAlertPanel("Fatal Error","Can't open console logfile","Quit",NULL,NULL);
		exit(1);
	}
	[window useOptimizedDrawing:YES];
	[window setFrameAutosaveName:"ConsoleView"];
	[window setFrameUsingName:"ConsoleView"];

	[text setMonoFont:YES];
	[text setEditable:NO];
	[text setSelectable:YES];
	[text setRetainedWhileDrawing:YES];

	timedEntry=DPSAddTimedEntry(ONE_TICK,&runOneTick,self,NX_BASETHRESHOLD);

	return self;
}

- appDidBecomeActive:sender
{
	[window makeKeyAndOrderFront:sender];
	return self;
}

- appWillTerminate:sender
{
	DPSRemoveTimedEntry(timedEntry);
	close(textFile);
	return self;
}

- showInfoPanel:sender
{
	if( infoPanel==nil && ![NXApp	loadNibSection:"Info.nib" owner:self withNames: NO])
		return nil;
	[infoPanel makeKeyAndOrderFront:nil];
    return self;
}


- ping:(double)tick
{
	static	length=0;
	static	mom,size;
	static	char *buffer;
	
	if(length!=(mom=lseek(textFile,0,SEEK_END)))
	{
		if(-1==mom)
		{
			NXRunAlertPanel("Fatal Error","Can't seek console logfile","Quit",NULL,NULL);
			DPSRemoveTimedEntry(timedEntry);
			exit(1);
		}
		size=mom-length;
		if(size<0)
		{
			length=0;
			size=mom;
		}
		buffer=(char *)malloc(size);
			lseek(textFile,length,SEEK_SET);
			if(-1==read(textFile,buffer,size))
			{
				NXRunAlertPanel("Fatal Error","Can't read console logfile","Quit",NULL,NULL);
				DPSRemoveTimedEntry(timedEntry);
				exit(1);
			}
			length+=size;
			[text setSel:[text textLength] :[text textLength]];
			[text replaceSel:(const char*)buffer length:size];
		free(buffer);
		
		[text setSel:[text textLength] :[text textLength]];
		[text scrollSelToVisible];
		[window orderWindow:NX_ABOVE relativeTo:0];
		[NXApp activateSelf:NO];
	}
	return self;
}

- clear:sender
{
	[text setSel:0 :[text textLength]];
	[text replaceSel:(const char*)NULL length:0];
    return self;
}


- hideAndClear:sender
{
	[NXApp hide:sender];
	[self clear:sender];
    return self;
}


@end
